/* gtkmdkbutton.c
 * 
 * This file is part of the MandrakeSoft Gtk Widgets Package
 * Copyright (C) 2000 DindinX <odin@mandrakesoft.com>
 * Copyright (C) 2000 MandrakeSoft
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include "gtkmdkbutton.h"

#include "gtkmdkintl.h"


static char * OK_xpm[] =
{
  "13 14 18 1",
  "   c None",
  ".  c #000000",
  "+  c #B3C2A7",
  "@  c #708C58",
  "#  c #859D71",
  "$  c #627B4D",
  "%  c #97AB86",
  "&  c #566C43",
  "*  c #A2BD9E",
  "=  c #789774",
  "-  c #88AC84",
  ";  c #5E764A",
  ">  c #698566",
  ",  c #6D8855",
  "'  c #688251",
  ")  c #668050",
  "!  c #6D8956",
  "~  c #4F633E",
  "         ..  ",
  "        .+@. ",
  "        .#$. ",
  "       .%@.  ",
  " ..    .#&.  ",
  ".*=.  .#@.   ",
  ".--.. .@&.   ",
  " .-=..;@.    ",
  " .-->.,&.    ",
  "  .--').     ",
  "   .-!~.     ",
  "   .--.      ",
  "    .>.      ",
  "     .       "};

static char * CANCEL_xpm[] =
{
  "13 14 8 1",
  "   c None",
  ".  c #000000",
  "+  c #C46D74",
  "@  c #9F3C44",
  "#  c #B5444E",
  "$  c #BD5A62",
  "%  c #7B2D34",
  "&  c #8C343C",
  "   ..      . ",
  "  .+@.    .#.",
  "  .##.   .$#.",
  "   .#@. .$#%.",
  "   .##..$#&. ",
  "    .####@.  ",
  "    .####.   ",
  "   .$###.    ",
  "  .$####.    ",
  " .$#&..#&.   ",
  ".+#&. .@#.   ",
  ".#&.   .#@.  ",
  " ..    .@#.  ",
  "        ..   "
};

static char *BACK_xpm [] =
{ 
  "14 14 33 1",
  "       c None",
  ".      c #000000",
  "+      c #C6D7C6",
  "@      c #E7EBE7",
  "#      c #FFFFFF",
  "$      c #DEEBDE",
  "%      c #F7F7F7",
  "&      c #DEE7DE",
  "*      c #EFF3EF",
  "=      c #101810",
  "-      c #B5C7AD",
  ";      c #EFEFEF",
  ">      c #D6E3D6",
  ",      c #213021",
  "'      c #315931",
  ")      c #52824A",
  "!      c #739A6B",
  "~      c #84A673",
  "{      c #7BA673",
  "]      c #84AA73",
  "^      c #84AA7B",
  "/      c #84AE7B",
  "(      c #63925A",
  "_      c #526D4A",
  ":      c #4A7D42",
  "<      c #739E6B",
  "[      c #739A63",
  "}      c #4A7539",
  "|      c #638E52",
  "1      c #427139",
  "2      c #6BA663",
  "3      c #5A8A52",
  "4      c #315929",
  "            ..",
  "          ..+.",
  "        ..@#+.",
  "      ..$#%%+.",
  "    ..&#%*%%+.",
  "  .=&#******+.",
  "..-#;>&@****+,",
  "..')!~{]^/^/(.",
  "  .._:<^~^/^(.",
  "    ..':[]~/(.",
  "      ..}:[~|.",
  "        ..123.",
  "          ..4.",
  "            .."
};

static char *NEXT_xpm [] =
{
  "14 14 36 1",
  "       c None",
  ".      c #000000",
  "+      c #E7EBDE",
  "@      c #FFFFFF",
  "#      c #F7F7EF",
  "$      c #D6E3D6",
  "%      c #F7F7F7",
  "&      c #EFF3EF",
  "*      c #CEDFCE",
  "=      c #CEDBC6",
  "-      c #E7EFE7",
  ";      c #181818",
  ">      c #292829",
  ",      c #E7EBE7",
  "'      c #DEE7DE",
  ")      c #B5C7AD",
  "!      c #9CBA94",
  "~      c #8CAE84",
  "{      c #84AA7B",
  "]      c #7BA673",
  "^      c #84A67B",
  "/      c #739A6B",
  "(      c #5A824A",
  "_      c #395931",
  ":      c #9CBA8C",
  "<      c #84AE7B",
  "[      c #739E6B",
  "}      c #527D4A",
  "|      c #425942",
  "1      c #84A673",
  "2      c #4A7142",
  "3      c #94B284",
  "4      c #395D31",
  "5      c #5A8652",
  "6      c #315929",
  "7      c #396531",
  "..            ",
  ".+..          ",
  ".@#$..        ",
  ".@%&#*..      ",
  ".@%%&&%=..    ",
  ".@&&&&&-#=;.  ",
  ">@&&&&,'$'&)..",
  ".!~{~{{]^/(_..",
  ".:{<{^{[}|..  ",
  ".:<1{/}2..    ",
  ".31/}4..      ",
  ".{56..        ",
  ".7..          ",
  "..            "
};

static char *HELP_xpm [] =
{
  "14 14 3 1",
  /* colors */
  ". c #808080",
  "# c #000080",
  "  c none",
  /* pixels */
  "              ",
  "     #####.   ",
  "    ##  .##.  ",
  "   ##.   ###  ",
  "   ##.   ###  ",
  "   .##  .##.  ",
  "        ##.   ",
  "       ##     ",
  "      ##.     ",
  "      ##.     ",
  "              ",
  "      ###     ",
  "      ###     ",
  "              ",
};
  
static void gtk_mdk_button_class_init(GtkMdkButtonClass *klass);
static void gtk_mdk_button_init(GtkMdkButton *mdk_button);
static void gtk_mdk_button_set_arg(GtkObject *object,
                                   GtkArg *arg, guint arg_id);
static void gtk_mdk_button_get_arg(GtkObject *object,
                                   GtkArg *arg, guint arg_id);
static void gtk_mdk_button_finalize(GtkObject *object);

static GtkButtonClass *mdk_button_parent_class = NULL;

/*************************************************************************/
GtkType gtk_mdk_button_get_type(void)
{
  static GtkType mdk_button_type = 0;

  if (!mdk_button_type)
  {
    static const GtkTypeInfo mdk_button_info =
    {
      "GtkMdkButton",
      sizeof(GtkMdkButton),
      sizeof(GtkMdkButtonClass),
      (GtkClassInitFunc)gtk_mdk_button_class_init,
      (GtkObjectInitFunc)gtk_mdk_button_init,
      /* reserved_1 */ NULL,
      /* reserved_2 */ NULL,
      (GtkClassInitFunc) NULL,
    };
    mdk_button_type = gtk_type_unique(GTK_TYPE_BUTTON, &mdk_button_info);
  }

  return mdk_button_type;
}

/*************************************************************************/
static void gtk_mdk_button_class_init(GtkMdkButtonClass *klass)
{
  GtkObjectClass *object_class;
  GtkWidgetClass *widget_class;
  object_class = (GtkObjectClass*) klass;
  widget_class = (GtkWidgetClass*) klass;

  mdk_button_parent_class = gtk_type_class(GTK_TYPE_BUTTON);
  
/*  gtk_object_add_arg_type("GtkMdkButton::Style", GTK_TYPE_ENUM,
                          GTK_ARG_READWRITE, ARG_STYLE_FILE);*/

  object_class->set_arg = gtk_mdk_button_set_arg;
  object_class->get_arg = gtk_mdk_button_get_arg;
  object_class->finalize = gtk_mdk_button_finalize;
/*  widget_class->realize = gtk_mdk_button_realize;*/
}

/*************************************************************************/
static void gtk_mdk_button_init(GtkMdkButton *mdk_button)
{

}

/*************************************************************************/
static void gtk_mdk_button_set_arg(GtkObject *object,
                                   GtkArg *arg, guint arg_id)
{

}

/*************************************************************************/
static void gtk_mdk_button_get_arg(GtkObject *object,
                                   GtkArg *arg, guint arg_id)
{

}

/*************************************************************************/
GtkWidget *gtk_mdk_button_new(GtkMdkButtonStyle style)
{
  GtkMdkButton *mdk_button;
  GtkWidget *hbox;
  GdkPixmap *pix;
  GdkBitmap *mask;
  GdkColor   trans;
  GtkWidget *pixmap;
  

  mdk_button = gtk_type_new(GTK_TYPE_MDK_BUTTON);
  mdk_button->style = style;
  hbox = gtk_hbox_new(5, FALSE);
  gtk_widget_show(hbox);
  gtk_container_add(GTK_CONTAINER(mdk_button), hbox);
  switch (mdk_button->style)
  {
    case GTK_BUTTON_OK:
      pix = gdk_pixmap_colormap_create_from_xpm_d(NULL,
                                           gtk_widget_get_default_colormap(),
                                           &mask,
                                           &trans,
                                           OK_xpm);
      pixmap = gtk_pixmap_new(pix, mask);
      gtk_widget_show(pixmap);
      gdk_pixmap_unref(pix);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), pixmap);
      mdk_button->label = gtk_label_new(_(" OK "));
      gtk_widget_show(mdk_button->label);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), mdk_button->label);
      break;
    case GTK_BUTTON_CANCEL:
      pix = gdk_pixmap_colormap_create_from_xpm_d(NULL,
                                           gtk_widget_get_default_colormap(),
                                           &mask,
                                           &trans,
                                           CANCEL_xpm);
      pixmap = gtk_pixmap_new(pix, mask);
      gtk_widget_show(pixmap);
      gdk_pixmap_unref(pix);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), pixmap);
      mdk_button->label = gtk_label_new(_(" Cancel "));
      gtk_widget_show(mdk_button->label);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), mdk_button->label);
      break;
    case GTK_BUTTON_BACK:
      pix = gdk_pixmap_colormap_create_from_xpm_d(NULL,
                                           gtk_widget_get_default_colormap(),
                                           &mask,
                                           &trans,
                                           BACK_xpm);
      pixmap = gtk_pixmap_new(pix, mask);
      gtk_widget_show(pixmap);
      gdk_pixmap_unref(pix);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), pixmap);
      mdk_button->label = gtk_label_new(_(" Back "));
      gtk_widget_show(mdk_button->label);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), mdk_button->label);
      break;
    case GTK_BUTTON_NEXT:
      pix = gdk_pixmap_colormap_create_from_xpm_d(NULL,
                                           gtk_widget_get_default_colormap(),
                                           &mask,
                                           &trans,
                                           NEXT_xpm);
      pixmap = gtk_pixmap_new(pix, mask);
      gtk_widget_show(pixmap);
      gdk_pixmap_unref(pix);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), pixmap);
      mdk_button->label = gtk_label_new(_(" Next "));
      gtk_widget_show(mdk_button->label);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), mdk_button->label);
      break;
    case GTK_BUTTON_HELP:
      pix = gdk_pixmap_colormap_create_from_xpm_d(NULL,
                                           gtk_widget_get_default_colormap(),
                                           &mask,
                                           &trans,
                                           HELP_xpm);
      pixmap = gtk_pixmap_new(pix, mask);
      gtk_widget_show(pixmap);
      gdk_pixmap_unref(pix);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), pixmap);
      mdk_button->label = gtk_label_new(_(" Help "));
      gtk_widget_show(mdk_button->label);
      gtk_box_pack_start_defaults(GTK_BOX(hbox), mdk_button->label);
      break;
  }
  return GTK_WIDGET(mdk_button);
}

/*************************************************************************/
static void gtk_mdk_button_finalize(GtkObject *object)
{
  GtkMdkButton *mdk_button;

  g_return_if_fail(object != NULL);
  g_return_if_fail(GTK_IS_MDK_BUTTON(object));

  mdk_button = GTK_MDK_BUTTON(object);

  (*GTK_OBJECT_CLASS(mdk_button_parent_class)->finalize)(object);
}


