/* gtkscaledpixmap.c
 * 
 * This file is part of the MandrakeSoft Gtk Widgets Package
 * Copyright (C) 2000 DindinX <odin@mandrakesoft.com>
 * Copyright (C) 2000 MandrakeSoft
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>
#include "gtkscaledpixmap.h"

#include "gtkmdkintl.h"

static void gtk_scaled_pixmap_class_init(GtkScaledPixmapClass *klass);
static void gtk_scaled_pixmap_init(GtkScaledPixmap *scaled_pixmap);

static GtkPixmapClass *scaled_pixmap_parent_class = NULL;

/*************************************************************************/
GtkType gtk_scaled_pixmap_get_type(void)
{
  static GtkType scaled_pixmap_type = 0;

  if (!scaled_pixmap_type)
  {
    static const GtkTypeInfo scaled_pixmap_info =
    {
      "GtkScaledPixmap",
      sizeof(GtkScaledPixmap),
      sizeof(GtkScaledPixmapClass),
      (GtkClassInitFunc)gtk_scaled_pixmap_class_init,
      (GtkObjectInitFunc)gtk_scaled_pixmap_init,
      /* reserved_1 */ NULL,
      /* reserved_2 */ NULL,
      (GtkClassInitFunc) NULL,
    };
    scaled_pixmap_type = gtk_type_unique(GTK_TYPE_PIXMAP, &scaled_pixmap_info);
  }

  return scaled_pixmap_type;
}

/*************************************************************************/
static void gtk_scaled_pixmap_class_init(GtkScaledPixmapClass *klass)
{

  scaled_pixmap_parent_class = gtk_type_class(GTK_TYPE_PIXMAP);
}

/*************************************************************************/
static void gtk_scaled_pixmap_init(GtkScaledPixmap *scaled_pixmap)
{

}

/**************************************************************************/
GtkWidget *gtk_scaled_pixmap_new(void)
{
  GtkScaledPixmap *scaled_pixmap;

  scaled_pixmap = gtk_type_new(GTK_TYPE_SCALED_PIXMAP);

  return GTK_WIDGET(mdk_button);
}

